#define _WIN32_WINDOWS	0x0500 
#define  WINVER			0x0400
#define OEMRESOURCE
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <mbstring.h>
#include <shlobj.h>
#include <commctrl.h>
#include <oledlg.h>
#include <process.h>
#include <richedit.h>
#include <WinUser.h>
#include <mmsystem.h>
#include <shellapi.h>
#include "resource.h"

#define APP (UINT)41000

//defines for _error
#define FATAL		1
#define CONTINUE	2

//defines for the OPTIONS dlg
#define MODIFYER_SHIFT	100
#define MODIFYER_CRTL	101
#define SHOWSETUP_FIRST	102
#define SHOWSETUP_LAST	103
#define SHOWSETUP_DONT	104
#define MODIFYER		105
#define FIRSTLAST		106
#define SETS			107
#define SET0			42000
#define SET1			42001
#define SET2			42002
#define SET3			42003
#define SET4			42004
#define SET5			42005
#define SET6			42006
#define SET7			42007


//defines for HOTSPOT regions
#define HOT_LEFTTOP			0
#define HOT_LEFTBOTTOM		1
#define HOT_TOPLEFT			2
#define HOT_TOPRIGHT		3
#define HOT_RIGHTTOP		4
#define HOT_RIGHTBOTTOM		5
#define HOT_BOTTOMLEFT		6
#define HOT_BOTTOMRIGHT		7
#define HOT_CAPTION			8

//typedefs for the functions in the hook-DLL	
typedef HHOOK (WINAPI* SETRUNITHOOK)(BOOL);
typedef BOOL (*SETSHIFT)(BOOL);
typedef BOOL (*SETKEYBOARD)(BOOL);
typedef BOOL (*SETCRTLSHIFTSETUP)(BOOL);
typedef BOOL (*SETHOOKMOUSE)(BOOL);
SETRUNITHOOK SetRUNITHook;
SETSHIFT SetSHIFT;
SETKEYBOARD SetKEYBOARD;
SETCRTLSHIFTSETUP SetCRTLSHIFTSETUP;
SETHOOKMOUSE SetHookMouse;

// for the shell32 undocumented PickIconDlg
typedef BOOL (CALLBACK* ICONPROC)(HWND, LPSTR, DWORD, LPDWORD);


//the structure that holds the information for each entry
//in the RUNit-list
struct APP2RUN
{
	//int iApp;						//don't know - have to check
	char szAppTit[_MAX_FNAME];		//the titel that appears in the list
	char szAppPat[MAX_PATH];		//the full path (&'*'&cmdline arguments)
	char szWorkDir[MAX_PATH];		//the working directory
	char szFileExt[_MAX_EXT];		//the extension (for faster access)
	char szSymbolFile[MAX_PATH];	//the full path to file that contains the icon that is displayed
	char szGroup[MAX_PATH];			//the name of the GROUP to which the entry belongs
	int idxSymbol;					//the index of the icon in szSymbolFile
	RECT rctWindow;					//the rect of the WindowPos
	int iRun;						//SHOW_state of the window
	//HBITMAP hbmSelect;				//the bitmaphandles of the menu-entry
	//HBITMAP hbmDeselect;
	int bmX;						//position in the large APPS-Bitmap
	int bmY;
	int bmCX;
	int bmCY;

};

struct MYMENUITEMS
{
	int iNum;
	int iNumTotal;
	int item[255];
};

struct MYMENU
{
	HWND hwnd;
	HWND hwndChild;
	int height;
	int width;
	int iPrevHilite;
	struct MYMENUITEMS items;
	char szName[255];

};


struct RUNIT_OPTIONS
{
	BOOL bShowIcons;
	BOOL bIconsLarge;
	BOOL b3D;
	BOOL bNoTray;
	LOGFONT lf;
	DWORD rgbFont;
	BOOL bModifyerSHIFT;
	int loc;
	int setup;
	BOOL bCRTLSHIFT; 
	//for the hackers
	BOOL bOldStyle;
	BOOL bNoSeps;
	BOOL bGodMode;
	BOOL bOpenSetupOnDrop;
	BOOL bKeyboard;
	int iLeftMouse;
	char szPath2SymbolLib[MAX_PATH];
	BOOL bOpenSingleItem;
	BOOL bPopupInCorners;
};

struct _SET
{
	HBITMAP hbmSetupSelect;
	HBITMAP hbmSetupDeselect;
	HBITMAP hbmApps;
	HDC		hdcMemApps;
	SIZE sizBitmap;
	char szFile[MAX_PATH];
	char szName[MAX_PATH];
	HMENU hMenu;
	int iApps;
	struct APP2RUN *ap;
		//WORKSHOP
	char szBGImage[MAX_PATH];
	HBITMAP hbmBG;
};

struct HOTRGN
{
	HRGN rgn;
	//struct _SET set;
	int iSet;
};

struct _RUNit
{	
	int iTooLarge;
	int iTooLargeSub;
	//int iCurrentCX;
	int spaceLeft;
	int spaceMiddle;
	int spaceRight;
	BOOL bShouldParseMenu;
	int iNumSets;
	int iActiveSet;
	WINDOWPOS wp;
	struct HOTRGN hotRegion[9];

};

// structures used to hold information about dialogitems
// in the setup dlg - needed for resizing the dialog
struct DLGITEMSRB // .. stick to right bottom
{
	int numItems;
	POINT pnt[20];
	int iWidth[20];
	int iHeight[20];
	int ID[20];
	int flags[20];
};
struct DLGITEMSRT// ... stick to right top
{
	int numItems;
	POINT pnt[20];
	int iWidth[20];
	int iHeight[20];
	int ID[20];
	int flags[20];
};
struct DLGITEMSTR// ... stick to ??? treeview
{
	int numItems;
	POINT pnt[20];
	int iWidth[20];
	int iHeight[20];
	int ID[20];
	int flags[20];
};


//database of visible windows
//used to find the main window that belongs to the launched program
struct WINDB
{
	int num;
	HWND hwnd[2048];
}winDB;


//struct for installed monitors
struct MONS
{
	int num;
	HANDLE hmon[16];
};


#define APPNAME "RUNit"
#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif
#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95 (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32







